//	Designed by : ѽ¹
//	2001.8.5
//	revision c
//
package jspFrameWork.dbframe;

import java.util.*;
import java.sql.*;
import java.io.*;
import jspFrameWork.util.*;

public abstract class DatabasePeer implements PersistentPeer 
{
  Connection con = null;
  ResultSet rs = null;
  ResultSetMetaData md = null;
  Statement stmt = null;
  
  public boolean insert() 
  {
  	int no = 0;
  	try
  	{
		con = DBConnectionManager.getInstance().getConnection("oracle");/////
	    stmt = con.createStatement();
	    no = stmt.executeUpdate(getInsertSql());
	  }
	  catch(SQLException sqlE)
	  {
	  	sqlE.printStackTrace();
	  }
	  finally 
	  {
      try 
      {
        if (stmt != null)   stmt.close();
        if (rs != null)     rs.close();
	    } 
	    catch(SQLException sqlE) 
	    {
		  	sqlE.printStackTrace();
	    }
	    DBConnectionManager.getInstance().freeConnection("oracle", con);/////
	  }
	  return( no > 0 ? true : false ); 
	}
	
	public boolean delete() 
	{
		int no = 0;
		try
		{
			con = DBConnectionManager.getInstance().getConnection("oracle");/////
			stmt = con.createStatement();
			no = stmt.executeUpdate(getDeleteSql());
		}
		catch(SQLException sqlE)
		{
			sqlE.printStackTrace();
		}
		finally 
		{
			try 
			{
				if (stmt != null)   stmt.close();
				if (rs != null)     rs.close();
			} 
			catch(SQLException sqlE) 
			{
			  	sqlE.printStackTrace();
			}
			DBConnectionManager.getInstance().freeConnection("oracle", con);/////
		}
		return( no > 0 ? true : false ); 
	}

	public boolean update() 
	{
		int no = 0;
		try
		{
			con = DBConnectionManager.getInstance().getConnection("oracle");/////
	    	stmt = con.createStatement();
	    	no = stmt.executeUpdate(getUpdateSql());
	  	}
		catch(SQLException sqlE)
		{
			sqlE.printStackTrace();
		}
		finally 
		{
			try 
			{
			    if (stmt != null)   stmt.close();
			    if (rs != null)     rs.close();
		    } 
		    catch(SQLException sqlE) 
		    {
			  	sqlE.printStackTrace();
		    }
		    DBConnectionManager.getInstance().freeConnection("oracle", con);/////
		}
		return( no > 0 ? true : false ); 
	}

	public Vector query() 
	{
		Vector tableV = new Vector();
	  	try
	  	{
			con = DBConnectionManager.getInstance().getConnection("oracle");/////
			stmt = con.createStatement();
//			System.out.println(getSelectSql());
			rs = stmt.executeQuery(getSelectSql());
			md = rs.getMetaData();
			int columnCount = md.getColumnCount();
			p.r(this,"columnCount1",columnCount);
			String[] row ;
			p.r(this,"columnCount2",columnCount);
			while (rs.next()) // skip
			{
				p.r(this,"while");
				row = new String[columnCount];
				p.r(this,"row",row);
				for (int i = 0; i < columnCount; i++) 
				{
					p.r(this,"for = i",i);
				  	row[i] = rs.getString(i+1);
				}
				tableV.addElement(row);

//					System.out.println( "\n*******Database Peer*************" );
				for(int no = 0 ; no < row.length ; no ++)
				{
//					System.out.print( "row[] : " + row[no] + "    |    " );
				}
//					System.out.println( "\n*********************************\n");

			}
		}
		catch(SQLException sqlE)
		{
			sqlE.printStackTrace();
		}
		finally 
		{
			try 
			{
				if (stmt != null)   stmt.close();
				if (rs != null)     rs.close();
			} 
			catch(SQLException sqlE) 
			{
			  	sqlE.printStackTrace();
			}
			p.r(this,"query()","freeConnection(oracle-1)");
			DBConnectionManager.getInstance().freeConnection("oracle", con);/////
			p.r(this,"query()","freeConnection(oracle-2)");
		}
		p.r(this,"tableV.size()",tableV.size());
		return tableV;
	}

	abstract String getInsertSql();
	
	abstract String getDeleteSql();
	
	abstract String getUpdateSql(); 
	
	abstract String getSelectSql(); 
} /* end class DatabasePeer */
