package jspFrameWork.view;

import jspFrameWork.control.*;
import jspFrameWork.view.*;
import jspFrameWork.dbframe.*;
import jspFrameWork.exception.*;
import jspFrameWork.util.*;

public class Presentation
{
	String page;
	private Presentation(String page)
	{
		this.page = page;
	}
	
	public static Presentation getPresentation( ParamMap paramMap)
	{
		p.r("Presentation","getPresentation");
		Presentation presentation = null;
		String page = null;
		String protocol = (String)paramMap.get("control");
		int control = Integer.parseInt(protocol);
		p.r("Presentation","control",control);
		
		switch (control)
		{
			case Protocol.CLIENT :
					page = "ClientInfo.jsp";
					break;
			case Protocol.ORDER :
					page = "OrderInfo.jsp";
					break;
			case Protocol.LOG :
					page = "LogInfo.jsp";
					break;
			case Protocol.ARCHIVE :
					page = "ArchiveInfo.jsp";
					break;
			default :
					throw new CodeException(" protocol error ! " );
		}
		p.r("presentation","page",page);
		presentation = new Presentation(page);
		p.r("presentation","protocol",protocol);
		p.r("presentation","control",control);
		return presentation;
	}
	
	public String getPage()
	{
		return page;
	}
}

		
	